]> git.saurik.com Git - apt.git/blob - cmdline/apt-key
* cmdline/apt-key:
[apt.git] / cmdline / apt-key
1 #!/bin/sh
2
3 set -e
4
5 # We don't use a secret keyring, of course, but gpg panics and
6 # implodes if there isn't one available
7
8 GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring /etc/apt/secring.gpg --trustdb-name /etc/apt/trustdb.gpg"
9 GPG="$GPG_CMD --keyring /etc/apt/trusted.gpg"
10
11
12 MASTER_KEYRING=""
13 ARCHIVE_KEYRING_URI=""
14 #MASTER_KEYRING=/usr/share/keyrings/debian-master-keyring.gpg
15 #ARCHIVE_KEYRING_URI=http://ftp.debian.org/debian/debian-archive-keyring.gpg
16
17 ARCHIVE_KEYRING=/usr/share/keyrings/debian-archive-keyring.gpg
18 REMOVED_KEYS=/usr/share/keyrings/debian-archive-removed-keys.gpg
19
20 add_keys_with_verify_against_master_keyring() {
21 ADD_KEYRING=$1
22 MASTER=$2
23
24 if [ ! -f "$ADD_KEYRING" ]; then
25 echo "ERROR: '$ADD_KEYRING' not found"
26 return
27 fi
28 if [ ! -f "$MASTER" ]; then
29 echo "ERROR: '$MASTER' not found"
30 return
31 fi
32
33 # when adding new keys, make sure that the archive-master-keyring
34 # is honored. so:
35 # all keys that are exported and have the name
36 # "Ubuntu Archive Automatic Signing Key" must have a valid signature
37 # from a key in the ubuntu-master-keyring
38 add_keys=`$GPG_CMD --keyring $ADD_KEYRING --with-colons --list-keys | grep ^pub | cut -d: -f5`
39 master_keys=`$GPG_CMD --keyring $MASTER --with-colons --list-keys | grep ^pub | cut -d: -f5`
40 for add_key in $add_keys; do
41 ADDED=0
42 for master_key in $master_keys; do
43 if $GPG_CMD --keyring $ADD_KEYRING --list-sigs --with-colons $add_key | grep ^sig | cut -d: -f5 | grep -q $master_key; then
44 $GPG_CMD --quiet --batch --keyring $ADD_KEYRING --export $add_key | $GPG --import
45 ADDED=1
46 fi
47 done
48 if [ $ADDED = 0 ]; then
49 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
50 fi
51 done
52 }
53
54 # update the current archive signing keyring from a network URI
55 # the archive-keyring keys needs to be signed with the master key
56 # (otherwise it does not make sense from a security POV)
57 net_update() {
58 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
59 echo "ERROR: no location for the archive-keyring given"
60 fi
61 if [ ! -d /var/lib/apt/keyrings ]; then
62 mkdir -p /var/lib/apt/keyrings
63 fi
64 keyring=/var/lib/apt/keyrings/$(basename $ARCHIVE_KEYRING)
65 old_mtime=0
66 if [ -e $keyring ]; then
67 old_mtime=$(stat -c %Y $keyring)
68 fi
69 (cd /var/lib/apt/keyrings; wget -q -N $ARCHIVE_KEYRING_URI)
70 if [ ! -e $keyring ]; then
71 return
72 fi
73 new_mtime=$(stat -c %Y $keyring)
74 if [ $new_mtime -ne $old_mtime ]; then
75 echo "Checking for new archive signing keys now"
76 add_keys_with_verify_against_master_keyring $keyring $MASTER_KEYRING
77 fi
78 }
79
80 update() {
81 if [ ! -f $ARCHIVE_KEYRING ]; then
82 echo >&2 "ERROR: Can't find the archive-keyring"
83 echo >&2 "Is the debian-archive-keyring package installed?"
84 exit 1
85 fi
86
87 # add new keys, if no MASTER_KEYRING is used, use the traditional
88 # way
89 if [ -z "$MASTER_KEYRING" ]; then
90 $GPG_CMD --quiet --batch --keyring $ARCHIVE_KEYRING --export | $GPG --import
91 else
92 add_keys_with_verify_against_master_keyring $ARCHIVE_KEYRING $MASTER_KEYRING
93 fi
94
95 # remove no-longer supported/used keys
96 keys=`$GPG_CMD --keyring $REMOVED_KEYS --with-colons --list-keys | grep ^pub | cut -d: -f5`
97 for key in $keys; do
98 if $GPG --list-keys --with-colons | grep ^pub | cut -d: -f5 | grep -q $key; then
99 $GPG --quiet --batch --delete-key --yes ${key}
100 fi
101 done
102 }
103
104
105 usage() {
106 echo "Usage: apt-key [command] [arguments]"
107 echo
108 echo "Manage apt's list of trusted keys"
109 echo
110 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
111 echo " apt-key del <keyid> - remove the key <keyid>"
112 echo " apt-key export <keyid> - output the key <keyid>"
113 echo " apt-key exportall - output all trusted keys"
114 echo " apt-key update - update keys using the keyring package"
115 echo " apt-key net-update - update keys using the network"
116 echo " apt-key list - list keys"
117 echo
118 }
119
120 command="$1"
121 if [ -z "$command" ]; then
122 usage
123 exit 1
124 fi
125 shift
126
127 if [ "$command" != "help" ] && ! which gpg >/dev/null 2>&1; then
128 echo >&2 "Warning: gnupg does not seem to be installed."
129 echo >&2 "Warning: apt-key requires gnupg for most operations."
130 echo >&2
131 fi
132
133 case "$command" in
134 add)
135 $GPG --quiet --batch --import "$1"
136 echo "OK"
137 ;;
138 del|rm|remove)
139 $GPG --quiet --batch --delete-key --yes "$1"
140 echo "OK"
141 ;;
142 update)
143 update
144 ;;
145 net-update)
146 net_update
147 ;;
148 list)
149 $GPG --batch --list-keys
150 ;;
151 finger*)
152 $GPG --batch --fingerprint
153 ;;
154 export)
155 $GPG --armor --export "$1"
156 ;;
157 exportall)
158 $GPG --armor --export
159 ;;
160 adv*)
161 echo "Executing: $GPG $*"
162 $GPG $*
163 ;;
164 help)
165 usage
166 ;;
167 *)
168 usage
169 exit 1
170 ;;
171 esac